/*
 *  H8 Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	H8 Common Functions
 */

#if TARGET_CPU == 3048

#include "3048.h"

#endif	/* of #ifdef TARGET_CPU == 3048 */

#if TARGET_CPU == 3052

#include "3052.h"

#endif	/* of #ifdef TARGET_CPU == 3052 */

#if TARGET_CPU == 3068

#include "3068.h"

#endif	/* of #ifdef TARGET_CPU == 3068 */

#if TARGET_CPU == 3069

#include "3069.h"

#endif	/* of #ifdef TARGET_CPU == 3069 */

#include "serial.h"
#include "comdefs.h"

		.h8300h

		.text
		.align		2

/*
 *	Byte to Hexadecimal ASCII
 *
 *		Input:	r3l: Input Byte
 *		Output:	r0:  ASCII Character
 */

Byte2HexASCII:
		mov.b		r3l, r0l
		mov.b		r3l, r0h
		shlr.b		r0h
		shlr.b		r0h
		shlr.b		r0h
		shlr.b		r0h
		cmp.b		#9, r0h
		bhi		Byte2HexASCII1
		add.b		#'0', r0h
		bra		Byte2HexASCII2

Byte2HexASCII1:
		add.b		#'a'-10, r0h

Byte2HexASCII2:
		and.b		#0x0f, r0l
		cmp.b		#9, r0l
		bhi		Byte2HexASCII3
		add.b		#'0', r0l
		bra		Byte2HexASCII4

Byte2HexASCII3:
		add.b		#'a'-10, r0l

Byte2HexASCII4:
		rts

/*
 *	check Hexadecimal number in ASCII
 *
 *		Input:	er3: Input Line
 *		Output:	r0l: Hexadecimal number, 0xff is not Hex
 *			er3: Input Line
 */

IsHexASCII:
		mov.b		@er3, r0l

		cmp.b		#'0' - 1, r0l
		bls		IsHexASCII3
		cmp.b		#'9', r0l
		bhi		IsHexASCII1
		add.b		#0 - '0', r0l		/* '0' - '9' */
		rts

IsHexASCII1:
		cmp.b		#'A' - 1, r0l
		bls		IsHexASCII3
		cmp.b		#'F', r0l
		bhi		IsHexASCII2
		add.b		#0 - ('A' - 10), r0l	/* 'A' - 'F' */
		rts

IsHexASCII2:
		cmp.b		#'a' - 1, r0l
		bls		IsHexASCII3
		cmp.b		#'f', r0l
		bhi		IsHexASCII3
		add.b		#0 - ('a' - 10), r0l	/* 'a' - 'f' */
		rts

IsHexASCII3:
		mov.b		#0xff, r0l
		rts

/*
 *	Hexadecimal ASCII to long word
 *
 *		Input:	er3: Input Line
 *			r4l: characrers
 *		Output:	er0: long word
 *			er3: Input Line
 */

_HexASCII2Long:
		push.w		r4
		push.l		er5

		sub.l		er5, er5
		bra		HexASCII2Long2

HexASCII2Long1:
		bsr		IsHexASCII
		cmp.b		#0xff, r0l
		beq		HexASCII2Long3

		sub.l		er1, er1
		mov.b		r0l, r1l
		shll.l		er5
		shll.l		er5
		shll.l		er5
		shll.l		er5
		add.l		er1, er5
		dec.b		r4l
		inc.l		#1, er3

HexASCII2Long2:
		and.b		r4l, r4l
		beq		HexASCII2Long3
		mov.b		@er3, r0l
		bne		HexASCII2Long1

HexASCII2Long3:
		mov.l		er5, er0
		pop.l		er5
		pop.w		r4
		rts

/*
 *	Skip Blanks
 *
 *		Input:	er3: Input Line
 *			er3: Input Line
 */

SkipBlanks1:
		cmp.b		#' ', r1l
		bne		SkipBlanks2
		inc.l		#1, er3

_SkipBlanks:
		mov.b		@er3, r1l
		bne		SkipBlanks1

SkipBlanks2:
		rts

/*
 *	Send Character with count
 *
 *		Input:	r3l: Serial Channel #
 *			r3h: Character sent
 *			e3 : Count
 */

_SendCharCount:
		push.w		e3
		inc.w		#1, e3
		bra		SendCharCount2
SendCharCount1:
		bsr		_SendChar:16
SendCharCount2:
		dec.w		#1, e3
		bne		SendCharCount1

		pop.w		e3
		rts

/*
 *	Send Null Terminated String
 *
 *		Input:	r3l: Serial Channel #
 *			er4: String sent
 *		Output:	er4: Address, End Of String + 1
 */

_SendString:
		push.w		r3
		bra		SendStr2
SendStr1:
		bsr		_SendChar:16
SendStr2:
		mov.b		@er4+, r3h
		bne		SendStr1

		pop.w		r3
		rts

/*
 *	Send Null Terminated String and CR/LF
 *
 *		Input:	r3l: Serial Channel #
 *			er4: String sent
 *		Output:	er4: Address, End Of String + 1
 */

_SendLine:
		bsr		_SendString
#if 0
		bsr		_SendLineTerm
		rts
#endif	/* of #if 0 */

/*
 *	Send Line Terminator (CR/LF)
 *
 *		Input:	r3l: Serial Channel #
 */

_SendLineTerm:
		push.w		r3

		mov.b		#0x0d, r3h
		bsr		_SendChar:16
		mov.b		#0x0a, r3h
		bsr		_SendChar:16

		pop.w		r3
		rts

/*
 *	Send Hexadecimal (1 digit)
 *
 *		Input:	r3l: Serial Channel #
 *			r3h: Hexadecimal Sent
 */

_SendHex:
		push.w		r3

		mov.b		r3h, r3l
		bsr		Byte2HexASCII:16
		mov.w		@sp, r3
		mov.b		r0l, r3h
		bsr		_SendChar:16

		pop.w		r3
		rts

/*
 *	Send Byte
 *
 *		Input:	r3l: Serial Channel #
 *			r3h: Byte Sent
 */

_SendByte:
		push.w		r3

		mov.b		r3h, r3l
		bsr		Byte2HexASCII:16
		mov.w		@sp, r3
		mov.b		r0h, r3h
		push.w		r0
		bsr		_SendChar:16
		pop.w		r0
		mov.b		r0l, r3h
		bsr		_SendChar:16

		pop.w		r3
		rts

/*
 *	Send Word
 *
 *		Input:	r3l: Serial Channel #
 *			r4:  Word Sent
 */

_SendWord:
		push.w		r3

		mov.b		r4h, r3h
		bsr		_SendByte
		mov.b		r4l, r3h
		bsr		_SendByte

		pop.w		r3
		rts

/*
 *	Send Long Word
 *
 *		Input:	r3l: Serial Channel #
 *			er4: Long Word Sent
 */

_SendLongWord:
		push.w		r4
		mov.w		e4, r4
		bsr		_SendWord
		pop.w		r4
		bsr		_SendWord

		rts

/*
 *	Initialize Recive Line
 *
 *		Input:	er3: Serial Channel #
 */

_InitRecLine:
		mov.l		er3, er0
		mov.b		r0h, @(InCharCount, er0)
		mov.l		er0, er1
		mov.b		#DEFAULT_LINE_SIZE + 1, r2l
		mulxu.b		r2l, r0
		add.l		#_InputLine, er0
		shll.w		r1
		shll.w		r1
		mov.l		er0, @(InLinePointer, er1)
		rts

/*
 *	Recive Line
 *
 *		Input:	r3l: Serial Channel #
 *		output: er0: Input Buffer, 0 if no line
 */

_ReciveLine:
		push.l		er5
		push.l		er4
		push.l		er3

		sub.l		er0, er0
		mov.b		r3l, r0l
		mov.l		er0, er4
		mov.b		#DEFAULT_LINE_SIZE + 1, r2l
		mulxu.b		r2l, r4
		add.l		#_InputLine, er4		/* er4: start address */
		mov.l		er0, er2
		shll.w		r2
		shll.w		r2
		mov.l		@(InLinePointer, er2), er5	/* er5: current address */
		mov.b		@(InCharCount, er0), r2l
		bne		ReciveLine4
ReciveLine1:
		bsr		_ReciveChar:16
		and.b		r0l, r0l
		beq		ReciveLine5

		mov.b		r0l, r3h
		cmp.b		#0x0a, r3h
		beq		ReciveLine1
		cmp.b		#0x08, r3h
		bne		ReciveLine2
		cmp.l		er4, er5
		beq		ReciveLine1
		bsr		_SendChar:16
		mov.b		#' ', r3h
		bsr		_SendChar:16
		mov.b		#0x08, r3h
		bsr		_SendChar:16
		dec.l		#1, er5
		bra		ReciveLine1
ReciveLine2:
		bsr		_SendChar:16
		cmp.b		#0x0d, r3h
		beq		ReciveLine3
		mov.b		r3h, @er5
		inc.l		#1, er5
		mov.l		er4, er0
		add.l		#DEFAULT_LINE_SIZE - 1, er0
		cmp.l		er0, er5
		bls		ReciveLine5
		mov.b		#0x0d, r3h
		bsr		_SendChar:16
ReciveLine3:
		mov.b		#0x0a, r3h
		bsr		_SendChar:16
		sub.l		er0, er0
		mov.b		r0l, @er5
		mov.b		r3l, r0l
		sub.l		er4, er5
		mov.b		r5l, @(InCharCount, er0)
ReciveLine4:
		mov.l		er4, er0
		bra		ReciveLine7
ReciveLine5:
		sub.l		er0, er0
		mov.b		r3l, r0l
		shll.w		r0
		shll.w		r0
		mov.l		er5, @(InLinePointer, er0)
ReciveLine6:
		sub.l		er0, er0
ReciveLine7:
		pop.l		er3
		pop.l		er4
		pop.l		er5
		rts

/*
 *	Recive Line with out echo
 *
 *		Input:	r3l: Serial Channel #
 *		output: er0: Input Buffer, 0 if no line
 */

_RecLineNoEcho:
		push.l		er5
		push.l		er4
		push.l		er3

		sub.l		er0, er0
		mov.b		r3l, r0l
		mov.l		er0, er4
		mov.b		#DEFAULT_LINE_SIZE + 1, r2l
		mulxu.b		r2l, r4
		add.l		#_InputLine, er4		/* er4: start address */
		mov.l		er0, er2
		shll.w		r2
		shll.w		r2
		mov.l		@(InLinePointer, er2), er5	/* er5: current address */
		mov.b		@(InCharCount, er0), r2l
		bne		RecLineNoEcho4
RecLineNoEcho1:
		bsr		_ReciveChar:16
		and.b		r0l, r0l
		beq		RecLineNoEcho5

		mov.b		r0l, r3h
		cmp.b		#0x0a, r3h
		beq		RecLineNoEcho1
		cmp.b		#0x08, r3h
		bne		RecLineNoEcho2
		cmp.l		er4, er5
		beq		RecLineNoEcho1
		dec.l		#1, er5
		bra		RecLineNoEcho1
RecLineNoEcho2:
		cmp.b		#0x0d, r3h
		beq		RecLineNoEcho3
		mov.b		r3h, @er5
		inc.l		#1, er5
		mov.l		er4, er0
		add.l		#DEFAULT_LINE_SIZE - 1, er0
		cmp.l		er0, er5
		bls		RecLineNoEcho5
RecLineNoEcho3:
		sub.l		er0, er0
		mov.b		r0l, @er5
		mov.b		r3l, r0l
		sub.l		er4, er5
		mov.b		r5l, @(InCharCount, er0)
RecLineNoEcho4:
		mov.l		er4, er0
		bra		RecLineNoEcho7
RecLineNoEcho5:
		sub.l		er0, er0
		mov.b		r3l, r0l
		shll.w		r0
		shll.w		r0
		mov.l		er5, @(InLinePointer, er0)
RecLineNoEcho6:
		sub.l		er0, er0
RecLineNoEcho7:
		pop.l		er3
		pop.l		er4
		pop.l		er5
		rts

/*
 *	Fill Long Word
 *
 *		Input:	er3: Start  Address
 *			er4: Length
 *			er5: Initial Data
 *			er6: Increase
 */

#if 0
_FillLong:
		push.l		er3
		push.l		er4
		push.l		er5
		push.l		er6
		bra		FillLong2
FillLong1:
		mov.l		@er3+ er5
		add.l		er5, er6
FillLong2:
		and.l		er4, er4
		bne		FillLong1

		pop.l		er6
		pop.l		er5
		pop.l		er4
		pop.l		er3
		rts
#endif	/* of #if 0 */

/*
 *	Move Long Word (Increment Type)
 *
 *		Input:	er3: Destination Address
 *			er4: Source      Address
 *			er5: Length
 */

_MoveLongInc:
		push.l		er3
		push.l		er4
		push.l		er5
		bra		MoveLongInc2
MoveLongInc1:
		mov.l		@er4+, er0
		mov.l		er0, @er3
		adds		#4, er3
		subs		#4, er5
MoveLongInc2:
		and.l		er5, er5
		bne		MoveLongInc1

		pop.l		er5
		pop.l		er4
		pop.l		er3
		rts

/*
 *	Optional Initialize Functions
 */

		.section	.rodata
		.align		4

_BeforeInitEntry:
		.long		_BeforeInit

_AfterInitEntry:
		.long		_AfterInit

/*
 *	Common Data
 */

		.bss

		.align		4

InLinePointer:	.space		4 * MAX_SERIAL
_AddressPointer:
		.space		4 * MAX_SERIAL
_DumpPointer:	.space		4 * MAX_SERIAL
_InputLine:	.space		(DEFAULT_LINE_SIZE + 1) * MAX_SERIAL
InCharCount:	.space		MAX_SERIAL
_CommandMode:	.space		MAX_SERIAL
_DataSize:	.space		MAX_SERIAL
_Status:	.space		MAX_SERIAL

		.align		4

		.end
